#!/bin/sh
#==========================================================
# FILE: startstop.sh
# DESC: Starts & stops screensaver modules in background
# BY:   Keaka Jackson 08/25/2002
# 
# Copyright (C) 2002 Sanity Software. All rights reserved.
#==========================================================

#===== TODO ========
# For the love of god, create functions for common code 
# such as starting and renicing the process.
#===== TODO ========

PATH=/usr/bin:/bin; export PATH

if [ $# -ne 3 ]; then
    # Invalid args given, use defaults
    MODULE="Flurry"
    CPU=+20
    RESTART="NO"
else    
    # First arg is module name
    MODULE=$1
    # Second arg is nice value
    CPU="$2"
    # Third arg indicates that if an effect is running, we
    # should stop it and start a new the new one.
    RESTART=$3
fi

# Look for process.  Call ps -ax to list all of the user's processes,
# then do a case insensitive compare to find all processes containing
# the ScreenSaverEngine.  We remove the grep command itself from the
# list, and finally we cut out the process id.  
PID=`ps -axww | grep -i "ScreenSaverEngine -background" | grep -v grep | cut -c 1-6`;
if [ "$PID" == "" ]; then
    if [ $RESTART == "NO" ]; then
	# Didn't find a pid so process isn't running and this
	# wasn't a restart, so start it.
	nice -n $CPU /System/Library/Frameworks/ScreenSaver.framework/Resources/ScreenSaverEngine.app/Contents/MacOS/ScreenSaverEngine -background -module "$MODULE" &
    fi
else
    # Found process, so stop it.
    # Send software termination signal
    kill -15 $PID
    if [ $RESTART == "YES" ]; then
	# Flag indicates we should restart a new module
	nice -n $CPU /System/Library/Frameworks/ScreenSaver.framework/Resources/ScreenSaverEngine.app/Contents/MacOS/ScreenSaverEngine -background -module "$MODULE" &
    fi
fi

exit 0  # always claim success
